#include "defs.h"
#include "keyb.h"
#include "10lcd.h"

char flash StepTable[12]={0x9,0xB,0xA,0x1A,0x12,0x16,0x14,0x34,0x24,0x25,0x21,0x29};
char const BrakeTable[12]={0x9,0x9,0xA,0xA,0x12,0x12,0x14,0x14,0x24,0x24,0x21,0x21};

//int flash  OCRTable[15]={2000, 1667, 1428, 1250, 1111, 1000, 950, 889, 800, 728, 666, 615, 572, 534, 500};
/*
	ਭ樯 ᫥ ⠡ ⮢  ᮮ⢥⢨  
묨 ⠬:
	 = Fosc / 筮_祭 / ᫮_ * 60;
	
	Fosc -  ,  襬 砥 = 4MHz;
	筮_祭 - 祭 ⮥  OCRTable;
	᫮_ - ⢮ 蠣    ⥫,
		 饬  = 240;
	60 - ⢮ ᥪ㭤   :).
 襣  񭭠 㫠:
	 = 10^6 / 筮_祭;
*/
int flash  OCRTable[15]={10000, 5000, 3333, 2500, 2000, 1667, 1428, 1250, 1111, 1000, 909, 833, 769, 714, 557};
char const tab_symb[16] = {' ','1','2','3','4','5','6','7',
			   '8','9','0','F','r','l','P','-'};
char const tab_data[16] = {0x0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7,
			   0x8, 0x9, 0xA, 0xB, 0xC, 0xD, 0xE, 0xF};

#define	shift_speed	6;
char	shift_cnt;

register char T0IRQcnt;	// Timer0 IRQ counter
#define	T0OVps	5
unsigned char T0IFcnt;
//unsigned int	StartUpCNT;
#define	StartUpTime	(1)
#define	printTime	(TOVps * 5)

register char	StepIndex;	// interrupt index for load from table
#define	BrakeTime	(12*3)	// brake time counter

void	SetRPM(char iv);
register char	rpm;		// valoarea turatsiilor / 20
register char	rpm_last;
register char	rpm_max, rpm_min;

register char	PWMcnt;		// PWM counter
register char	PWMval;		// PWM value
register char	PWMdiscret;	// PWM discretization value

char	tast;

register char Flags;
#define	LeftR		0x01	// if set left rotation, else right rotation
#define MotorON		0x02	// if set motor is on, else is turned off
#define	DirStat		0x04	// status of direction key 
#define LowRStat	0x08	// low rotation status flag 
#define T0IF		0x10	// Timer0 IF after divider

#define	LRkey		PINB.6	// key to change motor direction
#define	LowRkey		PINB.7	// Low rotation Key
#define	ONkey		PIND.2	// key to start motor
#define	OFFkey		PIND.3	// key to shot off it
#define	PWMout		PORTD.6 // PWM's output

void	putLCD(char symb_a);
void	printLCD(void);		// print to LCD from LCDbuff
register char	print_cnt;	// printLCD counter
char	LCDbuff[10];

void	indic_rpm(char irpm);	// send to LCDbuff input rpm value
void	indic_stat(void);	// send to LCDbuff device status

char	save_rpm_cnt;		// counter to store RPM value to eeprom

eeprom char rpm_low_index = 3;
eeprom char rpm_high_index = 5;
eeprom char eeprom_rpm = 3;
eeprom char eeprom_LeftR = 0;
eeprom char eeprom_tab_PWM_text[] = "tab_PWM=";
//eeprom char tab_PWM[16] = { 1, 2, 4, 6, 16, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32};
eeprom char tab_PWM[16] = { 1, 2, 6, 13, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32};
eeprom char eeprom_PWM_discret = 32;
void delay(void);